import { LoggerType } from '../logger';
import { StoreJsonCtrl } from '../fs/storeJsonController';
import { Dependencies } from '../installMultiple';
import { StoreJson } from '../fs/storeJsonController';
export declare type Package = {
    name: string;
    version: string;
    bin?: string | {
        [name: string]: string;
    };
    dependencies?: Dependencies;
    devDependencies?: Dependencies;
    optionalDependencies?: Dependencies;
    scripts?: {
        [name: string]: string;
    };
};
export declare type PackageAndPath = {
    pkg: Package;
    path: string;
};
export declare type CommandContext = {
    store: string;
    root: string;
    storeJson: StoreJson;
};
export declare type CommandNamespace = {
    pkg?: PackageAndPath;
    ctx: CommandContext;
    unlock(): void;
    storeJsonCtrl: StoreJsonCtrl;
};
export declare type BasicOptions = {
    cwd?: string;
    global?: boolean;
    globalPath?: string;
    storePath?: string;
    quiet?: boolean;
    logger?: LoggerType;
    ignoreScripts?: boolean;
};
export declare type StrictBasicOptions = {
    cwd: string;
    global: boolean;
    globalPath: string;
    storePath: string;
    quiet: boolean;
    logger: LoggerType;
    ignoreScripts: boolean;
};
export default function (opts: StrictBasicOptions): Promise<CommandNamespace>;
