"use strict";
const forceSymlink_1 = require('./forceSymlink');
const path = require('path');
const os = require('os');
// Always use "junctions" on Windows. Even though support for "symbolic links" was added in Vista+, users by default
// lack permission to create them
const symlinkType = os.platform() === 'win32' ? 'junction' : 'dir';
/*
 * Relative symlink
 */
function relSymlink(src, dest) {
    // Junction points can't be relative
    const rel = symlinkType !== 'junction' ? path.relative(path.dirname(dest), src) : src;
    return forceSymlink_1.default(rel, dest, symlinkType);
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = relSymlink;
//# sourceMappingURL=relSymlink.js.map