"use strict";
const path = require('path');
const fs = require('fs');
function storeJsonController(storePath) {
    const storeJsonPath = path.join(storePath, 'store.json');
    return {
        read() {
            try {
                return JSON.parse(fs.readFileSync(storeJsonPath, 'utf8'));
            }
            catch (err) {
                return null;
            }
        },
        save(storeJson) {
            fs.writeFileSync(storeJsonPath, JSON.stringify(storeJson, null, 2), 'utf8');
        }
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = storeJsonController;
//# sourceMappingURL=storeJsonController.js.map