import { PackageDist } from '../resolve';
import { InstallContext } from '../api/install';
import { Package } from '../api/initCmd';
export declare type PackageMeta = {
    rawSpec: string;
    optional: boolean;
};
export declare type InstallationOptions = {
    optional?: boolean;
    keypath?: string[];
    parentRoot?: string;
    linkLocal: boolean;
};
export declare type PackageSpec = {
    raw: string;
    name: string;
    scope: string;
    type: string;
    spec: string;
    rawSpec: string;
};
export declare type InstalledPackage = {
    pkg: Package;
    optional: boolean;
    fullname: string;
    keypath: string[];
    escapedName: string;
};
export declare type PackageContext = {
    optional: boolean;
    linkLocal: boolean;
    keypath: string[];
    fullname: string;
    dist: PackageDist;
};
export declare type InstallLog = (msg: string, data?: Object) => void;
export default function install(ctx: InstallContext, pkgMeta: PackageMeta, modules: string, options: InstallationOptions): Promise<InstalledPackage>;
