import { Agent as HttpAgent } from 'http';
export declare type GotOptions = {
    fetchRetries?: number;
    fetchRetryFactor?: number;
    fetchRetryMintimeout?: number;
    fetchRetryMaxtimeout?: number;
    concurrency?: number;
    headers?: {
        authorization: string;
    };
    agent?: HttpAgent;
};
export declare type HttpResponse = {
    body: string;
};
export declare type GetFunc = (url: string, options?: GotOptions) => Promise<HttpResponse>;
export declare type Got = {
    get: GetFunc;
    getStream: (url: string, options?: GotOptions) => Promise<NodeJS.ReadableStream>;
    getJSON<T>(url: string): Promise<T>;
};
declare var _default: (opts: GotOptions) => Got;
export default _default;
