import { PackageSpec } from '../install';
import { Got } from '../network/got';
export declare type PackageDist = {
    location: 'local' | 'remote' | 'dir';
    tarball: string;
    shasum?: string;
};
export declare type ResolveResult = {
    fullname: string;
    dist: PackageDist;
};
export declare type HostedPackageSpec = PackageSpec & {
    hosted: {
        type: string;
        shortcut: string;
    };
};
export declare type ResolveOptions = {
    log(msg: string): void;
    got: Got;
    root: string;
    linkLocal: boolean;
};
/**
 * Resolves a package in the NPM registry. Done as part of `install()`.
 *
 *     var npa = require('npm-package-arg')
 *     resolve(npa('rimraf@2'))
 *       .then((res) => {
 *         res.fullname == 'rimraf@2.5.1'
 *         res.dist == {
 *           shasum: '0a1b2c...'
 *           tarball: 'http://...'
 *         }
 *       })
 */
export default function (spec: PackageSpec, opts: ResolveOptions): Promise<ResolveResult>;
